"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function makeCancelable(promise) {
    var hasCanceled = false;
    var wrappedPromise = new Promise(function (resolve, reject) {
        promise
            .then(function (value) { return (hasCanceled ? reject({ isCanceled: true }) : resolve(value)); })
            .catch(function (error) { return (hasCanceled ? reject({ isCanceled: true }) : reject(error)); });
    });
    var cancel = function () {
        hasCanceled = true;
    };
    wrappedPromise.cancel = wrappedPromise.cancel || cancel;
    return wrappedPromise;
}
exports.default = makeCancelable;
//# sourceMappingURL=make-cancelable.js.map