import { InputFont, CancelablePromise, InitialFont, FontWithTiming, LoadedFont, FallbackFont } from './types';
/**
 * Creates new font observer based on font data
 * @param font - font data to observe
 */
export declare function load(font: InputFont, timeout?: number): CancelablePromise<InputFont>;
/**
 * Map font data for case when font is still waiting to be loaded
 */
export declare function dataWithLoadingFont({family, weight, style, stretch, class: cssClass, styles}: InputFont): InitialFont;
/**
 * Map font data for case when font is ready before timeout
 */
export declare function dataWithLoadedFont(font: InputFont | FontWithTiming): LoadedFont;
/**
 * Map font data for case when font timeouted to load
 */
export declare function dataWithFailedFont(font: InputFont): FallbackFont;
export declare const noop: () => void;
