/// <reference types="react" />
import * as React from 'react';
import { Font, Fonts, Options } from './types';
export interface State {
    [name: string]: Font;
}
/**
 * Wraps component with HoC and injects user-provided fonts props
 */
declare function withAsyncFonts<P>(fonts: Fonts, userOptions?: Options): (BaseComponent: React.ComponentType<P & State>) => React.ComponentClass<P & State>;
export default withAsyncFonts;
